#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

struct POKLON
{
	char *ime;
	char *poruka;
	int x,y;
	struct POKLON *sledeci;
};

struct POKLON *dodaj (struct POKLON *p, char *ime, char *poruka, int x, int y)
{
	struct POKLON *novi, *pom;
	
	
	novi=(struct POKLON *) malloc (sizeof(struct POKLON));
	if (novi == NULL)
	{
		printf("Greska");
		exit(0);
	}
	novi->ime = (char*)malloc(strlen(ime) +1);
	strcpy(novi->ime, ime);
	
	novi->poruka = (char*)malloc(strlen(poruka)+1);
	strcpy(novi->poruka, poruka);
	
	novi->x = x;
	novi->y = y;
	
	if(p==NULL)
	{
		p = novi;
	}
	else
	{
		novi->sledeci = p;
		p = novi;
	}
	
	return p;
}



struct POKLON *form_list (char *dat)
{
	struct POKLON *p;
	p = NULL;
	
	FILE *f;
	f=fopen(dat,"r");
	if(f==NULL)
	{
		printf("Greska pri otvaranju datoteke");
		exit(0);
	}
	
	int n;
	fscanf(f,"%d",&n);
	
	
	int i=0,x,y;
	char ime[50], poruka[50];
	
	while(i<n)
	{
		i++;
		fgetc(f);
		fgets(ime,50,f);
		ime[strlen(ime)-1] = '\0';
		
		fgets(poruka ,50,f);
		poruka[strlen(poruka)-1] = '\0';
		
		fscanf(f,"%d%d", &x, &y);
		
		p=dodaj(p,ime,poruka,x,y);
	}
	fclose(f);
	return p;
}



void pisi (struct POKLON *p)
{
	if(p == NULL) 
	{
		printf("Lista je prazna\n");
	}
	else
	{
		printf("\nIme \t Poruka \t x \t y\n");
		
		while(p!=NULL)
		{
			printf("%s \t %s \t %d \t %d\n", p->ime, p->poruka, p->x, p->y);
			p= p->sledeci;
		}
		printf("\n");
	}
}

double daljina_km (int a,int b, int c, int d)
{
	 double  x1,y1,x2,y2,z;
	 
	 x1 = 10 * a;
	 y1 = 10 * b;
	 x2 = 10 * c;
	 y2 = 10 * d;
	 
	 z = sqrt( ((x2-x1)* (x2-x1)) + ((y2-y1)*(y2-y1)) );
	 
	 return (z/1000);
 }
 
 
 
 /*
  * Deda Mraz kreće iz pozicije sa kordinatama (0,0). Za svaki poklon koji treba da isporuči proverava da li je
udaljenost od trenutne pozicije do mesta isporuke manja od M kilometara, i u ukoliko jeste isporučuje poklon, a
ukoliko nije, prebacuje ga u drugu torbu (koju puni po istom principu kao prvu). Vrednost M se unosi nakon
unetih svih poklona koje su vilenjaci spakovala, a razdaljina između dve susedne celobrojne koordinate na osi je
10m.
* 
Ispisati poklone koje Deda Mraz nije isporučio.

Nakon što isporuči sve poklone iz prve torbe Deda Mraz uzima drugu torbu i nastavlja isporuku po istom
principu, sve dok ne isporuči sve poklone ili dok, zbog velike udaljenosti, nije moguće da isporuči ni jedan od
preostalih poklona. Svaki put kada isprazni torbu ispisati sadržaj torbe sa neisporučenim poklonima.
Odredi i odštampati koliko kilometrara je Deda Mraz prešao pri isporuci poklona.

 */



struct POKLON *raspodela (struct POKLON *p, int *DM_x , int *DM_y, double M, double *presao, int *ind)
{
	struct POKLON *q, *obrisi;
	q=NULL;
	
	double razdaljina;

	int i,k;
	i=0;
	k=0;
	while(p!=NULL)
	{
		i++;
		razdaljina = daljina_km (*DM_x, *DM_y, p->x, p->y);
		
		if (razdaljina < M )
		{
			*presao = (*presao) + razdaljina;		
			*DM_x = p->x;
			*DM_y = p->y;
			obrisi = p;
			p = p->sledeci;
			free(obrisi);
		}
		else
		{
			k++;
			q=dodaj(q,p->ime,p->poruka,p->x, p->y) ;
			obrisi = p;
			p = p->sledeci;
			free(obrisi);
		}
	}
	if(q!=NULL)
	{
		printf("\n Pokloni koji nisu isporuceni\n");
		pisi (q);
	}
	else
	{
		printf("Svi pokloni su isporuceni");
	}
	
	if(i == k)
	{
		printf("NIje moguce isporuciti vise poklona ");
		*ind = 0;
	}
	
	
	return q;
}


struct POKLON *napravi_raspodelu (struct POKLON *p, double *presao)
{
	
	int ind =1;
	int DM_x=0, DM_y=0;
	
	double M;
	printf("Unesi M: ");
	scanf("%lf",&M);
	
	while (p!= NULL  && ind)
	{
		
		p = raspodela (p, &DM_x , &DM_y, M, presao, &ind);
	}
	
	return p;
}
main(int argc, char *argv[])
{
	struct POKLON *p;
	p = NULL;
	p = form_list(argv[1]);
	
	pisi(p);
	
	double presao = 0;
	p = napravi_raspodelu(p,&presao);
	
	printf("\nPresao je: %.2lf km\n", presao);
	
}
	
	
	
