#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>

typedef struct Poklon
{
	char imeprezime[100];
	char poruka[100];
	int x;
	int y;
} Poklon;

typedef struct torba
{
	Poklon poklon;
	struct torba *sledeci;
} torba;

#define aloc(x) x=(torba*)malloc(sizeof(torba))

void dodaj(torba **p,Poklon x);
void formiraj(torba **p, char dat[]);
void stampaj(torba *p);
float udaljenost(int x1, int y1, int x2, int y2);
void rasporediti(torba **p,int m,float *br);


int main(int argc, char *argv[])
{
	if (argc!=2)
	{
		printf("Greska! Upotreba: %s ime_datoteke\n",argv[0]);
		exit(1);
	}
	
	torba *p=NULL;
	int m;
	float ukupno;
	
	formiraj(&p,argv[1]);
	
	printf("\nLista poklona:\n");
	
	stampaj(p);
	
	printf("\nUnesite M: ");
	scanf("%d",&m);

	rasporediti(&p,m,&ukupno);
	
	printf("\nDeda Mraz je presao ukupno %.2f km.\n",ukupno/1000);
	
}

void dodaj(torba **p,Poklon x)
{
	torba *pom,*t;
	aloc(t);
	t->poklon=x;
	t->sledeci=*p;
	*p=t;
}
		
void formiraj(torba **p, char dat[])
{
	FILE *f=fopen(dat,"r");
	int n,i;
	Poklon x;
	
	if (!f)
	{
		printf("Greska prilikom otvaranja datoteke.\n");
		exit (1);
	}
	
	fscanf(f,"%d",&n);
	fgetc(f);
	
	for (i=0;i<n;i++)
	{
		fgets(x.imeprezime,256,f);
		fgets(x.poruka,256,f);
		fscanf(f,"%d%d",&x.x,&x.y);
		fgetc(f);
		dodaj(p,x);
	}
	
	fclose(f);
}
	
void stampaj(torba *p)
{
	torba *pom=p;
	
	while(pom)
	{
		printf("\n%s%s(%d,%d)\n",pom->poklon.imeprezime,pom->poklon.poruka,pom->poklon.x,pom->poklon.y);
		pom=pom->sledeci;
	}
}
	
float udaljenost(int x1, int y1, int x2, int y2)
{
	float s;
	s=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
	return s;
}
	
void rasporediti(torba **p,int m,float *br)
{
	torba *q=NULL,*pom1,*brisi;
	int xtren=0, ytren=0, ind=1;
	*br=0;
	
	while((*p)&&(ind))
	{
		pom1=*p;
		ind=0;
		
		while(pom1)
		{
			
				brisi=pom1;
				pom1=pom1->sledeci;
		
			
				if (udaljenost(brisi->poklon.x*10,brisi->poklon.y*10,xtren,ytren)>=m)
				dodaj(&q,brisi->poklon);
				else
				{
				*br+=udaljenost(brisi->poklon.x*10,brisi->poklon.y*10,xtren,ytren);
				xtren=brisi->poklon.x;
				ytren=brisi->poklon.y;
				
				
				
				ind=1;}
				free(brisi);
		}
		
		stampaj(q);
		*p=q;
	}
}
		
